
#ifndef __ES_COMMON_H__
#define __ES_COMMON_H__

#include "es_type.h"
#include "es_defines.h"
#include <string.h>
#include <stdlib.h>

#ifdef __cplusplus
#if __cplusplus
extern "C" {
#endif
#endif /* End of #ifdef __cplusplus */

#define ATTRIBUTE __attribute__((aligned(ES_ALIGN_NUM)))
#define ES_INVALID_CHN (-1)
#define ES_INVALID_DEV (-1)
#define ES_INVALID_HANDLE (-1)
#define ES_INVALID_VALUE (-1)

#define ES_DIE_0 (0)
#define ES_DIE_1 (1)

typedef ES_S32 AI_CHN;
typedef ES_S32 AO_CHN;
typedef ES_S32 AENC_CHN;
typedef ES_S32 ADEC_CHN;
typedef ES_S32 AUDIO_CARD;
typedef ES_S32 AUDIO_DEV;
typedef ES_S32 VI_DEV;
typedef ES_S32 VI_PIPE;
typedef ES_S32 VI_CHN;
typedef ES_S32 VI_STITCH_GRP;
typedef ES_S32 VO_DEV;
typedef ES_S32 VO_LAYER;
typedef ES_S32 VO_CHN;
typedef ES_S32 VO_WBC;
typedef ES_S32 GRAPHIC_LAYER;
typedef ES_S32 VENC_CHN;
typedef ES_S32 VDEC_GRP;
typedef ES_S32 VDEC_CHN;
typedef ES_S32 BLK_DEV;
typedef ES_S32 MIPI_DEV;
typedef ES_S32 VPS_GRP;
typedef ES_S32 VPS_CHN;
typedef ES_U32 VB_POOL;
typedef ES_U32 VB_BLK;
typedef ES_S32 DIE_IDX;

typedef union {
    struct esVERSION_NUM_S {
        ES_U16 patch;
        ES_U16 minor;
        ES_U32 major;
    } VERSION_NUM_S;
    ES_U64 version;
} ES_SDK_VERSION_U;

#define VERSION_NAME_MAXLEN 64

typedef enum esMOD_ID_E {
    ES_ID_VB = 1,
    ES_ID_SYS = 2,
    ES_ID_VDEC = 3,
    ES_ID_VPS = 4,
    ES_ID_VENC = 5,
    ES_ID_VO = 6,
    ES_ID_VI = 7,
    ES_ID_AIO = 8,
    ES_ID_AI = 9,
    ES_ID_AO = 10,
    ES_ID_AENC = 11,
    ES_ID_ADEC = 12,
    ES_ID_USER = 13,
    ES_ID_GDC = 14,
    ES_ID_NPU = 15,
    ES_ID_DSP = 16,
    ES_ID_BMS = 17,
    ES_ID_NUMA = 18,
    ES_ID_CIPHER = 19,
    ES_ID_AK = 20,
    ES_ID_MEMCP = 21,
    ES_ID_BUTT,
} MOD_ID_E;

typedef struct esCHN_S {
    MOD_ID_E modId;
    ES_S32 nId;
    ES_S32 devId;
    ES_S32 chnId;
} CHN_S;

typedef enum {
    PT_JPEG = 1,
    PT_H263 = 2,
    PT_AAC = 3,
    PT_MP3 = 4,
    PT_ADPCMA = 5,
    PT_H264 = 6,
    PT_H265 = 7,
    PT_MJPEG = 8,
    PT_G711A = 9,
    PT_G711U = 10,
    PT_G722 = 11,
    PT_G726 = 12,
    PT_AMR = 13,
    PT_MP2L2 = 14,
    PT_BUTT
} PAYLOAD_TYPE_E;

#ifdef __cplusplus
#if __cplusplus
}
#endif
#endif /* End of #ifdef __cplusplus */

#endif /* _ES_COMMON_H_ */
