
#ifndef __ES_DEFINES_H__
#define __ES_DEFINES_H__

#ifdef __cplusplus
#if __cplusplus
extern "C" {
#endif
#endif /* __cplusplus */

#define ES_ALIGN_NUM 8
#define ES_MAX_MMZ_NAME_LEN 64
#define ES_MAX_ALIGN 2048
#define ES_SEG_CMP_LENGTH 256
#define ES_DEFAULT_ALIGN 32

/* For VB */
#define ES_VB_MAX_POOLS 768

/* For VENC */
#define ES_VENC_MAX_CHN_NUM 128
#define ES_VENC_MAX_ROI_NUM 8
#define ES_VENC_QP_HISGRM_NUM 52
#define ES_VENC_MAX_SSE_NUM 8
#define ES_MAX_TILE_NUM 3

/* For RC */
#define ES_RC_TEXTURE_THR_SIZE 16

/* For VDEC */
#define ES_VDEC_MAX_GRP_NUM 128
#define ES_VDEC_OUT_CHN_NUM 2
#define ES_H264D_ALIGN_W 64
#define ES_H264D_ALIGN_H 16
#define ES_H265D_ALIGN_W 64
#define ES_H265D_ALIGN_H 64
#define ES_JPEGD_ALIGN_W 64
#define ES_JPEGD_ALIGN_H 16
#define ES_JPEGD_RGB_ALIGN 16

/* For VI */
#define ES_VI_MAX_DEV_NUM 6
#define ES_VI_MAX_PHY_PIPE_NUM 6
#define ES_VI_MAX_VIR_PIPE_NUM 2
#define ES_VI_MAX_PIPE_NUM (ES_VI_MAX_PHY_PIPE_NUM + ES_VI_MAX_VIR_PIPE_NUM)
#define ES_VI_MAX_PHY_CHN_NUM 3
#define ES_VI_MAX_EXT_CHN_NUM 8
#define ES_VI_MAX_CHN_NUM (ES_VI_MAX_PHY_CHN_NUM + ES_VI_MAX_EXT_CHN_NUM)

/* For VO */
#define ES_VO_MAX_VIRT_DEV_NUM 2                                                 /* max virtual dev num*/
#define ES_VO_MAX_PHY_DEV_NUM 2                                                  /* max physical dev num*/
#define ES_VO_MAX_DEV_NUM (ES_VO_MAX_PHY_DEV_NUM + ES_VO_MAX_VIRT_DEV_NUM)       /* max dev num */
#define ES_VO_MAX_VIRT_LAYER_NUM 2                                               /* max virtual layer num*/
#define ES_VO_MAX_PHY_LAYER_NUM 2                                                /* max physical layer num*/
#define ES_VO_MAX_LAYER_NUM (ES_VO_MAX_PHY_LAYER_NUM + ES_VO_MAX_VIRT_LAYER_NUM) /* max layer num */
#define ES_VO_MAX_CHN_NUM 64                                                     /* max channel num */
#define ES_VO_MAX_WBC_NUM 1

/* For AUDIO */
#define AI_DEV_MAX_NUM 1
#define AO_DEV_MIN_NUM 0
#define AO_DEV_MAX_NUM 2
#define AIO_MAX_NUM ((AO_DEV_MAX_NUM > AI_DEV_MAX_NUM) ? AO_DEV_MAX_NUM : AI_DEV_MAX_NUM)

/* For VPS */
#define ES_VPS_MAX_GRP_NUM 256
#define ES_VPS_MAX_CHN_NUM 3

/*For Gdc*/
#define ES_GDC_IP_NUM 2

#ifdef __cplusplus
#if __cplusplus
}
#endif
#endif /* __cplusplus */

#endif /* __ES_DEFINES_H__ */
